Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Interfaces/IDecisionListClassificationProblemData.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Interfaces/IDecisionListClassificationProblemData.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Interfaces/IDecisionListClassificationProblemData.cs	(revision 9392)
@@ -20,39 +20,10 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
 using HeuristicLab.Optimization.Operators.LCS;
-using HeuristicLab.Problems.DataAnalysis;
 
 namespace HeuristicLab.Encodings.DecisionList {
   public interface IDecisionListClassificationProblemData : IGAssistNichesProblemData {
-    Dataset Dataset { get; }
-    ICheckedItemList<StringValue> ConditionVariables { get; }
-    StringValue TargetVariable { get; }
-    IEnumerable<string> AllowedConditionVariables { get; }
-    //IEnumerable<string> AllowedTargetVariables { get; }
-
-    IntRange TrainingPartition { get; }
-    IntRange TestPartition { get; }
-
-    IEnumerable<int> TrainingIndices { get; }
-    IEnumerable<int> TestIndices { get; }
-
-    bool IsTrainingSample(int index);
-    bool IsTestSample(int index);
-
-    int Classes { get; }
-
     IValueParameter<Rule> SampleRuleParameter { get; }
-
-    DecisionListInput FetchInput(int row);
-    IEnumerable<DecisionListInput> FetchInput(IEnumerable<int> row);
-
-    IEnumerable<IAction> FetchAction(IEnumerable<int> rows);
-    IAction FetchAction(int rows);
-
-    event EventHandler Changed;
   }
 }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Interfaces/IDecisionListEvaluator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Interfaces/IDecisionListEvaluator.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Interfaces/IDecisionListEvaluator.cs	(revision 9392)
@@ -22,11 +22,9 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
-using HeuristicLab.Optimization;
+using HeuristicLab.Optimization.Operators.LCS;
 
 namespace HeuristicLab.Encodings.DecisionList {
-  public interface IDecisionListEvaluator : ISingleObjectiveEvaluator {
+  public interface IDecisionListEvaluator : IStrataSingleObjectiveEvaluator {
     ILookupParameter<DecisionList> DecisionListParameter { get; }
-    IValueLookupParameter<IntRange> EvaluationPartitionParameter { get; }
-    IValueLookupParameter<PercentValue> RelativeNumberOfEvaluatedSamplesParameter { get; }
     IValueLookupParameter<IDecisionListClassificationProblemData> ProblemDataParameter { get; }
     IValueLookupParameter<IntValue> SizePenaltyMinRulesParameter { get; }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Interfaces/IDecisionListSolution.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Interfaces/IDecisionListSolution.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Interfaces/IDecisionListSolution.cs	(revision 9392)
@@ -20,19 +20,14 @@
 #endregion
 
+using System;
+using HeuristicLab.Optimization.Operators.LCS;
 
-using System;
 namespace HeuristicLab.Encodings.DecisionList {
-  public interface IDecisionListSolution {
+  public interface IDecisionListSolution : IGAssistSolution {
     DecisionList Model { get; }
-    IDecisionListClassificationProblemData ProblemData { get; set; }
+    //IDecisionListClassificationProblemData ProblemData { get; set; }
 
     event EventHandler ModelChanged;
     event EventHandler ProblemDataChanged;
-
-    double TrainingAccuracy { get; }
-    double TestAccuracy { get; }
-    int TrainingNumberOfAliveRules { get; }
-    double TrainingTheoryLength { get; }
-    double TrainingExceptionsLength { get; }
   }
 }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Properties/AssemblyInfo.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Properties/AssemblyInfo.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Properties/AssemblyInfo.cs	(revision 9392)
@@ -55,3 +55,3 @@
 // [assembly: AssemblyVersion("1.0.*")]
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.7.9342")]
+[assembly: AssemblyFileVersion("3.3.7.9352")]
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Rule.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Rule.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Rule.cs	(revision 9392)
@@ -88,8 +88,8 @@
     }
 
-    public bool MatchInput(DecisionListInput target) {
+    public bool MatchInput(IGAssistInput target) {
       foreach (var variable in variables) {
-        if (!target.InputDictionary.ContainsKey(variable.Key)) { throw new ArgumentException("Input doesn't contain variable"); }
-        if (!variable.Value.Match(target.InputDictionary[variable.Key])) { return false; }
+        if (!target.VariableNames.Contains(variable.Key)) { throw new ArgumentException("Input doesn't contain variable"); }
+        if (!variable.Value.Match(target.GetVariableValue(variable.Key))) { return false; }
       }
       return true;
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Variable/DoubleVariable.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Variable/DoubleVariable.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Variable/DoubleVariable.cs	(revision 9392)
@@ -46,6 +46,8 @@
     protected DoubleVariable(DoubleVariable original, Cloner cloner)
       : base(original, cloner) {
-      discretizer = (IDiscretizer)original.discretizer.Clone();
-      curIntervals = new List<int>(original.curIntervals);
+      if (original.discretizer != null) {
+        discretizer = (IDiscretizer)original.discretizer.Clone();
+        curIntervals = new List<int>(original.curIntervals);
+      }
       maxIntervals = original.maxIntervals;
     }
@@ -68,5 +70,5 @@
 
       attributes = new List<bool>(numberOfIntervals);
-      var curIntervals = new List<int>(numberOfIntervals);
+      curIntervals = new List<int>(numberOfIntervals);
 
       for (int i = 0; i < numberOfIntervals - 1; i++) {
@@ -74,9 +76,9 @@
         microIntervals -= microInt;
         curIntervals.Add(microInt);
-        attributes[i] = random.NextDouble() < onePercentage;
+        attributes.Add(random.NextDouble() < onePercentage);
       }
       // add last interval
       curIntervals.Add(microIntervals);
-      attributes[numberOfIntervals - 1] = random.NextDouble() < onePercentage;
+      attributes.Add(random.NextDouble() < onePercentage);
     }
 
@@ -114,12 +116,13 @@
     }
 
-    private IList<double> GetValuesToCutPoints(IEnumerable<double> cutpoints, IEnumerable<int> microIntervals) {
+    private IList<double> GetValuesToCutPoints(IEnumerable<double> cutpoints, IList<int> microIntervals) {
       var intervalValues = new List<double>();
       var cutpointList = cutpoints.ToList();
-      int cur = 0;
-      foreach (var microInterval in microIntervals) {
-        cur += microInterval;
+      int cur = -1;
+      for (int i = 0; i < microIntervals.Count - 1; i++) {
+        cur += microIntervals[i];
         intervalValues.Add(cutpointList[cur]);
       }
+      intervalValues.Add(Double.PositiveInfinity);
       return intervalValues;
     }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Crossover/SinglePointCrossover.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Crossover/SinglePointCrossover.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Crossover/SinglePointCrossover.cs	(revision 9392)
@@ -62,5 +62,5 @@
       IList<IVariable> newCondition = new List<IVariable>(parent1Condition.VariableDictionary.Count);
 
-      var keyEnumerator = parent1Condition.Order.GetEnumerator();
+      var keyEnumerator = parent1Condition.VariableDictionary.Keys.GetEnumerator();
 
       int index = 0;
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Manipulator/UniformOnePositionInConditionManipulator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Manipulator/UniformOnePositionInConditionManipulator.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Manipulator/UniformOnePositionInConditionManipulator.cs	(revision 9392)
@@ -54,5 +54,5 @@
         throw new ArgumentOutOfRangeException();
       }
-      var keyEnumerator = condition.Order.GetEnumerator();
+      var keyEnumerator = condition.VariableDictionary.Keys.GetEnumerator();
       int count = 0;
       keyEnumerator.MoveNext();
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/DoubleVariable.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/DoubleVariable.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/DoubleVariable.cs	(revision 9392)
@@ -130,7 +130,7 @@
       var targetCast = target as DoubleVariable;
       if (targetCast == null) { return false; }
-      if (variableName != targetCast.variableName || currentCenter.IsAlmost(targetCast.currentCenter)
-        || currentSpread.IsAlmost(targetCast.currentSpread) || max.IsAlmost(targetCast.max)
-        || min.IsAlmost(targetCast.min)) { return false; }
+      if (variableName != targetCast.variableName || !currentCenter.IsAlmost(targetCast.currentCenter)
+        || !currentSpread.IsAlmost(targetCast.currentSpread) || !max.IsAlmost(targetCast.max)
+        || !min.IsAlmost(targetCast.min)) { return false; }
 
       return true;
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/IntVariable.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/IntVariable.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/IntVariable.cs	(revision 9392)
@@ -133,8 +133,12 @@
         || currentValue != targetCast.currentValue) { return false; }
 
-      if (possibleFeatures.Except(targetCast.possibleFeatures).Count() != 0
-        || targetCast.possibleFeatures.Except(possibleFeatures).Count() != 0) { return false; }
+      var thisEnumerator = possibleFeatures.GetEnumerator();
+      var castEnumerator = targetCast.possibleFeatures.GetEnumerator();
+      while (thisEnumerator.MoveNext() && castEnumerator.MoveNext()) {
+        if (thisEnumerator.Current != castEnumerator.Current)
+          return false;
+      }
 
-      return true;
+      return !thisEnumerator.MoveNext() && !castEnumerator.MoveNext();
     }
 
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/StringVariable.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/StringVariable.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/StringVariable.cs	(revision 9392)
@@ -87,5 +87,5 @@
       featureMapping = new Dictionary<int, string>();
       var distinctValuesEnumerator = variableValues.Distinct().GetEnumerator();
-      possibleFeatures = Enumerable.Range(0, featureMapping.Count());
+      possibleFeatures = Enumerable.Range(0, variableValues.Count());
       var possibleFeaturesEnumerator = possibleFeatures.GetEnumerator();
       while (possibleFeaturesEnumerator.MoveNext() && distinctValuesEnumerator.MoveNext()) {
@@ -178,12 +178,13 @@
         || currentValue != targetCast.currentValue) { return false; }
 
-      if (featureMapping.Keys.Except(targetCast.featureMapping.Keys).Count() != 0
-        || targetCast.featureMapping.Keys.Except(featureMapping.Keys).Count() != 0) { return false; }
-
-      foreach (var keyValuePair in targetCast.featureMapping) {
-        if (!featureMapping[keyValuePair.Key].Equals(keyValuePair.Value)) { return false; }
-      }
-
-      return true;
+      var thisEnumerator = featureMapping.GetEnumerator();
+      var castEnumerator = targetCast.featureMapping.GetEnumerator();
+      while (thisEnumerator.MoveNext() && castEnumerator.MoveNext()) {
+        if (thisEnumerator.Current.Key != castEnumerator.Current.Key ||
+          thisEnumerator.Current.Value != castEnumerator.Current.Value)
+          return false;
+      }
+
+      return !thisEnumerator.MoveNext() && !castEnumerator.MoveNext();
     }
 
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorActionComparer.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorActionComparer.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorActionComparer.cs	(revision 9392)
@@ -21,5 +21,4 @@
 
 using System.Collections.Generic;
-using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -43,11 +42,15 @@
 
     public bool Equals(VariableVectorAction x, VariableVectorAction y) {
-      if (!x.Order.SequenceEqual(y.Order)) return false;
-      foreach (var key in x.VariableDictionary.Keys) {
-        if (!x.VariableDictionary[key].Identical(y.VariableDictionary[key])) {
-          return false;
+      //if (!x.Order.SequenceEqual(y.Order)) return false;
+      var xEnumerator = x.VariableDictionary.Keys.GetEnumerator();
+      var yEnumerator = y.VariableDictionary.Keys.GetEnumerator();
+      while (xEnumerator.MoveNext() && yEnumerator.MoveNext())
+        foreach (var key in x.VariableDictionary.Keys) {
+          if (xEnumerator.Current != yEnumerator.Current ||
+            !x.VariableDictionary[xEnumerator.Current].Identical(y.VariableDictionary[yEnumerator.Current])) {
+            return false;
+          }
         }
-      }
-      return true;
+      return !xEnumerator.MoveNext() && !yEnumerator.MoveNext();
     }
 
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorCondition.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorCondition.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorCondition.cs	(revision 9392)
@@ -39,6 +39,4 @@
       protected set { variableDictionary = value; }
     }
-
-    public IOrderedEnumerable<string> Order { get { return VariableDictionary.Keys.OrderBy(x => x); } }
 
     public int VirtualLength { get { return VariableDictionary.Values.Sum(x => x.VirtualLength); } }
@@ -110,11 +108,15 @@
 
     public bool Identical(VariableVectorCondition target) {
-      if (!this.Order.SequenceEqual(target.Order)) { return false; }
-      foreach (var keyValuePair in target.VariableDictionary) {
-        if (!VariableDictionary[keyValuePair.Key].Identical(keyValuePair.Value)) {
+      var thisEnumerator = VariableDictionary.GetEnumerator();
+      var targetEnumerator = target.VariableDictionary.GetEnumerator();
+
+      while (thisEnumerator.MoveNext() && targetEnumerator.MoveNext()) {
+        if (thisEnumerator.Current.Key != targetEnumerator.Current.Key ||
+          !thisEnumerator.Current.Value.Identical(targetEnumerator.Current.Value)) {
           return false;
         }
       }
-      return true;
+
+      return !thisEnumerator.MoveNext() && !targetEnumerator.MoveNext();
     }
   }
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Discretizer/IDiscretizer.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Discretizer/IDiscretizer.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Discretizer/IDiscretizer.cs	(revision 9392)
@@ -25,4 +25,5 @@
 namespace HeuristicLab.Optimization.Operators.LCS {
   public interface IDiscretizer : IItem {
+    IEnumerable<double> DiscretizeValues(string attribute, IEnumerable<double> values);
     int NumberOfMicroIntervals(string attribute);
     IEnumerable<double> GetCutPoints(string attribute);
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Discretizer/InitializeDiscretizersOperator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Discretizer/InitializeDiscretizersOperator.cs	(revision 9392)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Discretizer/InitializeDiscretizersOperator.cs	(revision 9392)
@@ -0,0 +1,72 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Optimization.Operators.LCS {
+  [Item("InitializeDiscretizersOperator", "Description missing")]
+  [StorableClass]
+  public class InitializeDiscretizersOperator : SingleSuccessorOperator {
+
+    #region Parameter Properties
+    public ILookupParameter<IGAssistNichesProblemData> ProblemDataParameter {
+      get { return (ILookupParameter<IGAssistNichesProblemData>)Parameters["ProblemData"]; }
+    }
+    public ILookupParameter<ItemCollection<IDiscretizer>> DiscretizersParameter {
+      get { return (ILookupParameter<ItemCollection<IDiscretizer>>)Parameters["Discretizers"]; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected InitializeDiscretizersOperator(bool deserializing) : base(deserializing) { }
+    protected InitializeDiscretizersOperator(InitializeDiscretizersOperator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public InitializeDiscretizersOperator()
+      : base() {
+      Parameters.Add(new LookupParameter<IGAssistNichesProblemData>("ProblemData", ""));
+      Parameters.Add(new LookupParameter<ItemCollection<IDiscretizer>>("Discretizers", ""));
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new InitializeDiscretizersOperator(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      var dataset = ProblemDataParameter.ActualValue.Dataset;
+      var trainingIndizes = ProblemDataParameter.ActualValue.TrainingIndices;
+      var conditionVariables = ProblemDataParameter.ActualValue.ConditionVariables.CheckedItems.Select(x => x.Value.Value);
+
+      foreach (var variable in dataset.DoubleVariables.Where(x => conditionVariables.Contains(x))) {
+        var values = dataset.GetDoubleValues(variable, trainingIndizes);
+        foreach (var discretizer in DiscretizersParameter.ActualValue) {
+          discretizer.DiscretizeValues(variable, values);
+        }
+      }
+
+      return base.Apply();
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Discretizer/UniformWidthDiscretizer.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Discretizer/UniformWidthDiscretizer.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Discretizer/UniformWidthDiscretizer.cs	(revision 9392)
@@ -20,5 +20,4 @@
 #endregion
 
-using System;
 using System.Collections.Generic;
 using System.Linq;
@@ -42,8 +41,9 @@
     protected UniformWidthDiscretizer(UniformWidthDiscretizer original, Cloner cloner)
       : base(original, cloner) {
+      this.bins = original.bins;
+      this.variableMicroItervals = new Dictionary<string, IList<double>>(original.variableMicroItervals);
     }
     public UniformWidthDiscretizer()
-      : base() {
-      bins = 5;
+      : this(5) {
     }
     public UniformWidthDiscretizer(int bins)
@@ -60,9 +60,5 @@
     }
 
-    public IEnumerable<double> discretizeValues(string attribute, IEnumerable<double> values) {
-      if (variableMicroItervals.ContainsKey(attribute)) {
-        throw new ArgumentException("Values of attribute " + attribute + " are already set.");
-      }
-
+    public IEnumerable<double> DiscretizeValues(string attribute, IEnumerable<double> values) {
       double min = values.Min();
       double max = values.Max();
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/IGAssistNichesProblemData.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/IGAssistNichesProblemData.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/IGAssistNichesProblemData.cs	(revision 9392)
@@ -20,9 +20,37 @@
 #endregion
 
+using System;
 using System.Collections.Generic;
 using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Problems.DataAnalysis;
 
 namespace HeuristicLab.Optimization.Operators.LCS {
   public interface IGAssistNichesProblemData : INamedItem {
+    Dataset Dataset { get; }
+    ICheckedItemList<StringValue> ConditionVariables { get; }
+    StringValue TargetVariable { get; }
+    IEnumerable<string> AllowedConditionVariables { get; }
+    //IEnumerable<string> AllowedTargetVariables { get; }
+
+    IntRange TrainingPartition { get; }
+    IntRange TestPartition { get; }
+
+    IEnumerable<int> TrainingIndices { get; }
+    IEnumerable<int> TestIndices { get; }
+
+    bool IsTrainingSample(int index);
+    bool IsTestSample(int index);
+
+    int Classes { get; }
+
+    IGAssistInput FetchInput(int row);
+    IEnumerable<IGAssistInput> FetchInput(IEnumerable<int> row);
+
+    IEnumerable<IGAssistNiche> FetchAction(IEnumerable<int> rows);
+    IGAssistNiche FetchAction(int rows);
+
+    event EventHandler Changed;
+
     IEnumerable<IGAssistNiche> GetPossibleNiches();
   }
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/IGAssistProblem.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/IGAssistProblem.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/IGAssistProblem.cs	(revision 9392)
@@ -21,6 +21,9 @@
 
 using HeuristicLab.Core;
+
 namespace HeuristicLab.Optimization.Operators.LCS {
   public interface IGAssistProblem : ISingleObjectiveHeuristicOptimizationProblem {
+    new IStrataSingleObjectiveEvaluator Evaluator { get; }
+
     IParameter ProblemDataParameter { get; }
     string NichingParameterName { get; }
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/ILAS/ILASOperator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/ILAS/ILASOperator.cs	(revision 9392)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/ILAS/ILASOperator.cs	(revision 9392)
@@ -0,0 +1,110 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Optimization.Operators.LCS {
+  [Item("ILASOperator", "Description missing")]
+  [StorableClass]
+  public class ILASOperator : SingleSuccessorOperator, IStochasticOperator {
+
+    #region Parameter Properties
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
+    }
+    public ILookupParameter<IGAssistNichesProblemData> ProblemDataParameter {
+      get { return (ILookupParameter<IGAssistNichesProblemData>)Parameters["ProblemData"]; }
+    }
+    public IValueLookupParameter<IntValue> NumberOfStrataParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["NumberOfStrata"]; }
+    }
+    public IValueLookupParameter<ItemList<ItemList<IntValue>>> StrataParameter {
+      get { return (IValueLookupParameter<ItemList<ItemList<IntValue>>>)Parameters["Strata"]; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected ILASOperator(bool deserializing) : base(deserializing) { }
+    protected ILASOperator(ILASOperator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public ILASOperator()
+      : base() {
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The random generator to use."));
+      Parameters.Add(new LookupParameter<IGAssistNichesProblemData>("ProblemData", ""));
+      Parameters.Add(new ValueLookupParameter<IntValue>("NumberOfStrata", ""));
+      Parameters.Add(new ValueLookupParameter<ItemList<ItemList<IntValue>>>("Strata", ""));
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ILASOperator(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      if (StrataParameter.ActualValue == null) {
+        //initialize strata
+        int numberOfStrata = NumberOfStrataParameter.ActualValue.Value;
+        var strata = new ItemList<ItemList<IntValue>>(numberOfStrata);
+        for (int i = 0; i < numberOfStrata; i++) {
+          strata.Add(new ItemList<IntValue>());
+        }
+
+        //get all rows for every niche
+        var problemData = ProblemDataParameter.ActualValue;
+        IntRange evaluate = ProblemDataParameter.ActualValue.TrainingPartition;
+        Dictionary<IGAssistNiche, List<int>> nicheRows = null;
+        for (int row = evaluate.Start; row < evaluate.End; row++) {
+          if (problemData.IsTrainingSample(row)) {
+            var niche = problemData.FetchAction(row);
+            if (nicheRows == null) {
+              nicheRows = new Dictionary<IGAssistNiche, List<int>>(niche.Comparer);
+            }
+            if (!nicheRows.ContainsKey(niche)) {
+              nicheRows.Add(niche, new List<int>());
+            }
+            nicheRows[niche].Add(row);
+          }
+        }
+
+        //distribute niches to strata
+        var random = RandomParameter.ActualValue;
+        foreach (var niche in nicheRows.Keys) {
+          var rows = nicheRows[niche];
+          int count = 0;
+          while (rows.Count > 0) {
+            int pos = random.Next(rows.Count);
+            strata[count % numberOfStrata].Add(new IntValue(rows[pos]));
+            rows.RemoveAt(pos);
+            count++;
+          }
+        }
+
+        StrataParameter.ActualValue = strata;
+      }
+      return base.Apply();
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistIndividual.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistIndividual.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistIndividual.cs	(revision 9392)
@@ -30,4 +30,6 @@
     void ApplyMerge(IRandom random, double probability);
     void ApplyReinitialize(IRandom random, double probability, double oneProbability, IEnumerable<IDiscretizer> discretizers);
+
+    IGAssistSolution CreateGAssistSolution(IGAssistNichesProblemData problemData);
   }
 }
